#!/usr/bin/env python
# -*- coding: utf-8 -*-
#
#   unv2neutral.py
#
#       unv形式のメッシュファイルをneutral形式に変換
#
#
#   18/03/03    新規作成
#


import sys
import os
import glob


#
#  unv2abaqus
#    unvからabaqus形式に変換
def unv2abaqus(unvFileName, abaFileName):
    print
    print "convert unv to abaqus..."
    comm = "unv2abaqusEx.py " + unvFileName + " " + abaFileName + " N"
    print comm
    os.system(comm)
    
#
#  abaqus2neutral
#    abaqus形式からneutral形式に変換
def abaqus2neutral(abaFileName, neuFileName):
    print
    print "convert abaqus to neutral..."
    comm = "abaqus2neutral.py " + abaFileName + " " + neuFileName
    print comm
    os.system(comm)



if __name__=='__main__':
    unvFileName = sys.argv[1]
    words = unvFileName.split(".")
    if words[-1] != "unv":
        unvFileName += ".unv"
    words = unvFileName.split(".")
    abaFileName = ".".join(words[:-1])
    unv2abaqus(unvFileName, abaFileName)
    neuFileName = ".".join(words[:-1]) + ".mesh"
    abaqus2neutral(abaFileName, neuFileName)

